/**
  *  \file recog_bmp.c
  *
  *  This recognizes BMP images.
  */

#include "ripper.h"
#include "ringbuf.h"
#include "recog.h"

int
recog_bmp(M* m, BUF* b, size_t len)
{
    unsigned long  length, hdr_size;
    unsigned short bits;

    if (len < 50 || buf_peek(b, 0) != 'B' || buf_peek(b, 1) != 'M')
        return 0;
    length = get_l32(b, 2);
    if (length > 50) {
        hdr_size = get_l32(b, 14);
        bits     = get_l16(b, 28);
        if (get_l32(b, 6) == 0 && get_l32(b, 30) < 10
            && hdr_size >= 40 && hdr_size < 1000 && bits < 48)
        {
            match_set_ext(m, "bmp");
            match_set_length(m, length);
            return 1;
        } else {
            return 0;
        }
    } else {
        return 0;
    }
}

REC bmp_recognizer = { "bmp", "B", recog_bmp };
