/**
  *  \file recog_dir.c
  *
  *  This recognizes MS-DOS directory entries.
  */

#include "recog.h"

int
recog_dir(M* m, BUF* b, size_t len)
{
    size_t index;
    if (! buf_streq(b, 0, ".          "))
        return 0;

    index = 0;
    while (index < len && buf_peek(b, index) != 0)
        index += 32;

    match_set_ext(m, "dir");
    match_set_length(m, index);
    return 1;
}

REC dir_recognizer = { "dir", ".", recog_dir };
